#ifndef __DRYGASCON_ARM_SELECTOR_H__
#define __DRYGASCON_ARM_SELECTOR_H__
//Optional file to select the best implementation for each chip

#ifdef STM32H743xx
    #define __DRYGASCON_ARM_SELECTOR_V7M__
    #define __DRYGASCON_ARM_SELECTOR_FPU__
#endif

#ifdef STM32F746xx
    #define __DRYGASCON_ARM_SELECTOR_V7M__
    #define __DRYGASCON_ARM_SELECTOR_FPU__
#endif

#ifdef STM32F103xx
    #define __DRYGASCON_ARM_SELECTOR_V7M__
#endif

#ifdef STM32L011xx
    #define __DRYGASCON_ARM_SELECTOR_V6M__
#endif

#ifdef __SAM3X8E__
    #define __DRYGASCON_ARM_SELECTOR_V7M__
#endif

//TODO: add more chips here

#ifdef __DRYGASCON_ARM_SELECTOR_V7M__
    #ifdef __DRYGASCON_ARM_SELECTOR_FPU__
        #define DRYGASCON_G_OPT   drygascon128_g_v7m_fpu
        #define DRYGASCON_F_OPT   drygascon128_f_v7m_fpu
        #define DRYGASCON_G0_OPT drygascon128_g0_v7m_fpu
    #else
        #define DRYGASCON_G_OPT   drygascon128_g_v7m
        #define DRYGASCON_F_OPT   drygascon128_f_v7m
        #define DRYGASCON_G0_OPT drygascon128_g0_v7m
    #endif
#endif

#ifdef __DRYGASCON_ARM_SELECTOR_V6M__
        #define DRYGASCON_G_OPT   drygascon128_g_v6m
        #define DRYGASCON_F_OPT   drygascon128_f_v6m
        //#define DRYGASCON_G0_OPT drygascon128_g0_v6m
        #define DRYGASCON_ALIGN_INPUT_32
#endif

#ifndef __DRYGASCON_ARM_SELECTOR_FOUND__
#error "No ARM definition found"
#endif

#endif
